
-- all my quads are essentially the same.
--quad = love.graphics.newQuad( x, y, width, height, sw, sh )

--x; The top-left position along the x-axis.
--y; The top-left position along the y-axis.
--width; The width of the Quad. (Must be greater than 0.)
--height; The height of the Quad. (Must be greater than 0.)
--sw; The reference width, the width of the Image. (Must be greater than 0.)
--sh; The reference height, the height of the Image. (Must be greater than 0.)


--create table of quads
--spritesheet; string
--qw,qw;	quad width and height
function loadQuads(spritesheet,qw,qh)
	--get sheet dimensions
	local image = love.graphics.newImage( spritesheet )
	local sw=image:getWidth()
	local sh=image:getHeight()
	
	--get number of columns and rows
	local c=math.floor(sw/qw) --maybe make this ceiling instead
	local r=math.floor(sh/qh) --maybe make this ceiling instead

	--prep output table
	local newq=love.graphics.newQuad--( x, y, width, height, sw, sh )
	local q={}

	--make output table
	for i=1,c do
		q[i]={}
		for j=1,r do
			q[i][j]=newq((i-1)*qw,(j-1)*qh,qw,qh,sw,sh)
		end
	end
	
	return q
end


--love.graphics.drawq( image, quad, x, y, r, sx, sy, ox, oy, kx, ky )
-- image An image to texture the quad with.
-- quad The quad to draw on screen.
-- x The position to draw the object (x-axis).
-- y The position to draw the object (y-axis).
-- r (0) Orientation (radians).
-- sx (1) Scale factor (x-axis).
-- sy (sx) Scale factor (y-axis).
-- ox (0) Origin offset (x-axis).
-- oy (0) Origin offset (y-axis).

--[[this may involve drawing multiple layers over one another.
function drawSprite(image,quad,x, y, r, sx, sy, ox, oy, kx, ky)

	local lg=love.graphics
	local lgd=love.graphics.drawq
	local lgc=love.graphics.setColor
	lg.drawq( image, quad, x, y, r, sx, sy, ox, oy, kx, ky )

end
--]]

--[[
object={
	frame=1, -- animation frame; set to 1 every time state changes.
	frameMove=1 -- may be set negative, depending on animation style; set to 1 every time state changes.
}

animation={
	{qx,qy,seconds}, --first quad
	{qx,qy,seconds} --second quad
	}

in order to last 1 second, use 1*dt.
in order to last 2 seconds, use 1/2*dt.

so dt/seconds
--]]

--test animation, three sprites in a row
animation={
	{1,1,1},
	{1,2,1},
	{1,3,1}
	}

function animate(o,animation,dt)

	local a=animation
	local f=o.frame -- animation frame; set to 1 every time state changes
	local m=#animation --number of frames in current animation set
	
	o.frame=o.frame+dt/a[3]

	-- this iteration is kept within bounds by the corresponding draw function.
	
end

function draw(image,quadList,o,animation,type)--,x, y, r, sx, sy, ox, oy, kx, ky) ; this extra stuff should be gotten from o (object)

	if type='repeat' then --no prob
		elseif type=='reverse' then --no prob
		else type='repeat' end
	end

	local f=math.floor(o.frame)
	
	local m=#animation --number of frames in current animation set
	
	if o.frame>m and type=='repeat' then
		o.frame=1
		f=1
	elseif o.frame>2*m and type=='reverse' then
		o.frame=1
		f=2*m-o.frame
	end
	
	
	local a=animation
	local qx=a[f][1]
	local qy=a[f][2]
	local quad=quadList[qx][qy]
	
	--insert function to draw quad.  May inlcude various sprites.
	
	--this is a stand-in
	love.graphics.drawq( image, quad, o.x, o.y)--), o.r, o.sx, o.sy, o.ox, o.oy, o.kx, o.ky )
	
	
end
	
